-- ============================================================
--   Database name:  FOLHA
--   DBMS name:      ORACLE Version 12.x
--   Created on:     25/07/2022  16:46
--   Issue:          388072 - Portal do funcionário - Adicionar campo que o colaborador terá que justificar a marcação manual
-- ============================================================

-- ===============================================================
--   Table: GPE_PARAMORG
-- ===============================================================
ALTER TABLE GPE_PARAMORG ADD IDEXIGEAPROVMARCPF VARCHAR2(1) DEFAULT 'N' NOT NULL
    CONSTRAINT CKC_IDEXIGEAPROVMARCPF_PARAMOR CHECK (IDEXIGEAPROVMARCPF IN ('S','N'));

-- ============================================================
--   Table: GPE_MARCACAOPONTO
-- ============================================================
ALTER TABLE GPE_MARCACAOPONTO ADD IDEXIGEAPROVACAO VARCHAR2(1) DEFAULT 'N' NULL
    CONSTRAINT CKC_IDEXIGEAPROVACAO_GPE_MARCA CHECK (IDEXIGEAPROVACAO IN ('S','N'));

-- ============================================================
--   Table: PTO_TIPOPROGOCORRENCIA
-- ============================================================
INSERT INTO PTO_TIPOPROGOCORRENCIA (
    NRTIPOPROGOCORRENCIA, 
    NRORG,
    NRORDEMPROGOCORRENCIA,
    CDTIPOPROGOCORRENCIA, 
    NMTIPOPROGOCORRENCIA, 
    DSOBSERVACAO,
    IDPROGOCORACONFIRMAR, 
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU
) VALUES (
    30,
    0,
    240,
    'MARCACAO_AUTORIZADA',
    'Autorizar marcação',
    'Faz com que marcações que exigem aprovação sejam devidamente interpretadas como válidas.',
    'S',
    'S',
    1,
    SYSDATE,
    1,
    NULL,
    NULL,
    NULL
);
