CREATE OR REPLACE
PROCEDURE USR_EXPO_SAP_ME_ENDERECO
IS
   V_CCOMMIT        INTEGER;
   V_ALTERACAO      VARCHAR2(01);
   V_IDENTIFICADOR  INTEGER;
   V_PAIS           VARCHAR2(30);
   V_MUNICIPIO      VARCHAR2(30);
   V_TPINTERFACE    VARCHAR2(01);
   V_STATUS         VARCHAR2(01);
   V_CLAVE          VARCHAR2(06);
   V_NRINSJURFILI   VARCHAR2(20);
   V_CDINSCESTA     VARCHAR2(16);
   V_DSLOCAL        VARCHAR2(300);
   V_IDENTIFIC      INTEGER;
BEGIN
   V_CCOMMIT   := 0;
   /* Fixo T */
   V_ALTERACAO := 'T';
   V_PAIS := '';
   V_MUNICIPIO := '';
   /* I - Incluso
      A - Alterao
      E - Excluso */
   V_TPINTERFACE := 'I';
   /* 0 - OK
      1 - Novo
      2 - Erro
      3 - Em Processo */
   V_STATUS := 1;
   V_CLAVE := '';

   FOR C_PAIS IN (SELECT P.CDPAIS, P.NMPAIS
                    FROM PAIS P
                   WHERE P.USR_IDINTEGRAMESAP = 'S') LOOP

      UPDATE USR_SAP_ME_ENDERECO
         SET PAIS   = C_PAIS.NMPAIS
       WHERE CDPAIS = C_PAIS.CDPAIS;

      UPDATE PAIS
         SET USR_IDINTEGRAMESAP = 'N'
       WHERE CDPAIS = C_PAIS.CDPAIS;

      COMMIT;
   END LOOP;

   FOR C_MUNICIPIO IN (SELECT M.CDPAIS, M.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO
                         FROM MUNICIPIO M
                        WHERE M.USR_IDINTEGRAMESAP = 'S') LOOP

      UPDATE USR_SAP_ME_ENDERECO
         SET MUNICIPIO   = C_MUNICIPIO.NMMUNICIPIO
       WHERE CDPAIS      = C_MUNICIPIO.CDPAIS
         AND ESTADO      = C_MUNICIPIO.SGESTADO
         AND CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO;

      UPDATE MUNICIPIO
         SET USR_IDINTEGRAMESAP = 'N'
       WHERE CDPAIS      = C_MUNICIPIO.CDPAIS
         AND SGESTADO    = C_MUNICIPIO.SGESTADO
         AND CDMUNICIPIO = C_MUNICIPIO.CDMUNICIPIO;

      COMMIT;
   END LOOP;

   FOR C_BAIRRO IN (SELECT B.CDPAIS, B.SGESTADO, B.CDMUNICIPIO, B.CDBAIRRO, B.NMBAIRRO
                      FROM BAIRRO B
                     WHERE B.USR_IDINTEGRAMESAP = 'S') LOOP

      UPDATE USR_SAP_ME_ENDERECO
         SET BAIRRO      = C_BAIRRO.NMBAIRRO
       WHERE CDPAIS      = C_BAIRRO.CDPAIS
         AND ESTADO      = C_BAIRRO.SGESTADO
         AND CDMUNICIPIO = C_BAIRRO.CDMUNICIPIO
         AND CDBAIRRO    = C_BAIRRO.CDBAIRRO;

      UPDATE BAIRRO
         SET USR_IDINTEGRAMESAP = 'N'
       WHERE CDPAIS      = C_BAIRRO.CDPAIS
         AND SGESTADO    = C_BAIRRO.SGESTADO
         AND CDMUNICIPIO = C_BAIRRO.CDMUNICIPIO
         AND CDBAIRRO    = C_BAIRRO.CDBAIRRO;

      COMMIT;
   END LOOP;

   FOR C_ENDERECO IN (/* Endereo de entrega da filial */
                      SELECT E.IDUSR_SAP_ME_ENDERECO, F.CDFILIAL, 'E' IDTIPOENDERECO, E.CDPAIS,
                             P.NMPAIS, E.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, E.DSENDEFILI ENDERECO,
                             E.DSCOMPENDFIL COMPLEMENTO, E.NMCONTFILI CONTATO, E.NRTELEFILI TEL,
                             E.DSEMAILFILI EMAIL, NVL(B.NMBAIRRO, E.NMBAIRFILI) BAIRRO,
                             E.NRCEPFILI CEP, E.IDTPENDEFILI IDTPENDE, NULL CDCLIENTE, NULL IDTABELA,
                             NULL CDEMPRESA, NULL CDINSCESTA, 'F' IDTABALTTEK
                        FROM FILIAL F INNER JOIN ENDEFILI E ON F.CDFILIAL = E.CDFILIAL
                                      INNER JOIN PAIS P ON E.CDPAIS = P.CDPAIS
                                      INNER JOIN MUNICIPIO M ON M.CDPAIS      = E.CDPAIS
                                                            AND M.SGESTADO    = E.SGESTADO
                                                            AND M.CDMUNICIPIO = E.CDMUNICIPIO
                                      LEFT  JOIN BAIRRO B ON B.CDPAIS      = E.CDPAIS
                                                         AND B.SGESTADO    = E.SGESTADO
                                                         AND B.CDMUNICIPIO = E.CDMUNICIPIO
                                                         AND B.CDBAIRRO    = E.CDBAIRRO
                       WHERE NVL(E.USR_IDINTEGRAMESAP, 'S') = 'S'
                         AND E.IDTPENDEFILI = CASE (SELECT IDTPENDEFILI
                                                      FROM ENDEFILI
                                                     WHERE IDTPENDEFILI = 'T'
                                                       AND CDFILIAL = F.CDFILIAL) WHEN 'T'
                                                                                  THEN 'T'
                                                                                  ELSE 'P' END
                         AND E.DSENDEFILI IS NOT NULL
                       UNION
                      /* Endereo de faturamento */
                      SELECT E.IDUSR_SAP_ME_ENDERECO_FAT IDUSR_SAP_ME_ENDERECO, C.CDFILIAL, 'F' IDTIPOENDERECO, E.CDPAIS,
                             P.NMPAIS, E.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, E.DSENDECLIE ENDERECO,
                             E.DSCOMPENDCLI COMPLEMENTO, E.NMCONTCLIE CONTATO, E.NRTELECLIE TEL,
                             E.DSEMAILCLIE EMAIL, NVL(B.NMBAIRRO, E.NMBAIRCLIE) BAIRRO,
                             E.NRCEPCLIE CEP, E.IDTPENDECLIE IDTPENDE, E.CDCLIENTE, NULL IDTABELA,
                             NULL CDEMPRESA, NULL CDINSCESTA, 'C' IDTABALTTEK
                        FROM CLIENFILIAL C INNER JOIN ENDECLIE E ON C.CDCLIENTE = E.CDCLIENTE
                                           INNER JOIN PAIS P ON E.CDPAIS = P.CDPAIS
                                           INNER JOIN MUNICIPIO M ON M.CDPAIS      = E.CDPAIS
                                                                 AND M.SGESTADO    = E.SGESTADO
                                                                 AND M.CDMUNICIPIO = E.CDMUNICIPIO
                                           LEFT  JOIN BAIRRO B ON B.CDPAIS      = E.CDPAIS
                                                              AND B.SGESTADO    = E.SGESTADO
                                                              AND B.CDMUNICIPIO = E.CDMUNICIPIO
                                                              AND B.CDBAIRRO    = E.CDBAIRRO
                       WHERE ( (NVL(E.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                               (NVL(C.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                               (EXISTS (SELECT 1
                                          FROM ENDEFILI EN
                                         WHERE EN.CDFILIAL = C.CDFILIAL
                                           AND EN.DSENDEFILI IS NOT NULL
                                           AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                              )
                         AND E.IDTPENDECLIE = 'P'
                         AND E.IDUSR_SAP_ME_ENDERECO IS NULL
                         AND E.DSENDECLIE IS NOT NULL
                         AND C.IDCLIENPRIN = 'S'
                       UNION
                      /* Endereo de cobrana */
                      SELECT E.IDUSR_SAP_ME_ENDERECO, C.CDFILIAL, 'C' IDTIPOENDERECO, E.CDPAIS,
                             P.NMPAIS, E.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, E.DSENDECLIE ENDERECO,
                             E.DSCOMPENDCLI COMPLEMENTO, E.NMCONTCLIE CONTATO, E.NRTELECLIE TEL,
                             E.DSEMAILCLIE EMAIL, NVL(B.NMBAIRRO, E.NMBAIRCLIE) BAIRRO,
                             E.NRCEPCLIE CEP, E.IDTPENDECLIE IDTPENDE, E.CDCLIENTE, NULL IDTABELA,
                             NULL CDEMPRESA, NULL CDINSCESTA, 'C' IDTABALTTEK
                        FROM CLIENFILIAL C INNER JOIN ENDECLIE E ON C.CDCLIENTE = E.CDCLIENTE
                                           INNER JOIN PAIS P ON E.CDPAIS = P.CDPAIS
                                           INNER JOIN MUNICIPIO M ON M.CDPAIS      = E.CDPAIS
                                                                 AND M.SGESTADO    = E.SGESTADO
                                                                 AND M.CDMUNICIPIO = E.CDMUNICIPIO
                                           LEFT  JOIN BAIRRO B ON B.CDPAIS      = E.CDPAIS
                                                              AND B.SGESTADO    = E.SGESTADO
                                                              AND B.CDMUNICIPIO = E.CDMUNICIPIO
                                                              AND B.CDBAIRRO    = E.CDBAIRRO
                       WHERE ( (NVL(E.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                               (NVL(C.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                               (EXISTS (SELECT 1
                                          FROM ENDEFILI EN
                                         WHERE EN.CDFILIAL = C.CDFILIAL
                                           AND EN.DSENDEFILI IS NOT NULL
                                           AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                             )
                         AND E.IDTPENDECLIE = 'P'
                         AND E.IDUSR_SAP_ME_ENDERECO_FAT IS NULL
                         AND E.DSENDECLIE IS NOT NULL
                         AND C.IDCLIENPRIN = 'S'
                       UNION
                      /* Endereo de faturamento */
                      SELECT E.IDUSR_SAP_ME_ENDERECO_FAT IDUSR_SAP_ME_ENDERECO, E.CDFILIAL, 'F' IDTIPOENDERECO, I.CDPAIS,
                             P.NMPAIS, I.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, I.DSENDEIEST ENDERECO,
                             I.DSCOMPENDIES COMPLEMENTO, I.NMREPRINSEST CONTATO, I.NRTELEIEST TEL,
                             '' EMAIL, NVL(B.NMBAIRRO, I.NMBAIRIEST) BAIRRO,
                             I.NRCEPIEST CEP, 'P' IDTPENDE, NULL CDCLIENTE, E.IDTABELA, E.CDEMPRESA,
                             I.CDINSCESTA CDINSCESTA, CASE WHEN IDTABELA = 'E' THEN '1' ELSE '2' END IDTABALTTEK
                        FROM INSCRESTAD I INNER JOIN (SELECT F.CDFILIAL, EF.CDEMPRESA, EF.CDINSCESTA, EF.IDUSR_SAP_ME_ENDERECO_FAT, 'R' IDTABELA
                                                        FROM FILIAL F INNER JOIN EMPRCNTRFIL EF ON F.CDFILIAL = EF.CDFILIAL
                                                       WHERE NVL(EF.USR_IDINTEGRAMESAP, 'S') = 'S'
                                                       UNION
                                                      SELECT F.CDFILIAL, EF.CDEMPRESA, F.CDINSCESTA, EF.IDUSR_SAP_ME_ENDERECO_FAT, 'E' IDTABELA
                                                        FROM FILIAL F INNER JOIN EMPRESA EF ON F.CDEMPRESA = EF.CDEMPRESA
                                                       WHERE NVL(EF.USR_IDINTEGRAMESAP, 'S') = 'S') E ON I.CDEMPRESA  = E.CDEMPRESA
                                                                                                     AND I.CDINSCESTA = E.CDINSCESTA
                                          INNER JOIN PAIS P ON I.CDPAIS = P.CDPAIS
                                          INNER JOIN MUNICIPIO M ON M.CDPAIS      = I.CDPAIS
                                                                AND M.SGESTADO    = I.SGESTADO
                                                                AND M.CDMUNICIPIO = I.CDMUNICIPIO
                                          LEFT  JOIN BAIRRO B ON B.CDPAIS      = I.CDPAIS
                                                             AND B.SGESTADO    = I.SGESTADO
                                                             AND B.CDMUNICIPIO = I.CDMUNICIPIO
                                                             AND B.CDBAIRRO    = I.CDBAIRRO
                       WHERE I.DSENDEIEST IS NOT NULL
                         AND ((I.USR_IDINTEGRAMESAP = 'N') OR
                              (EXISTS (SELECT 1
                                         FROM ENDEFILI EN
                                        WHERE EN.CDFILIAL = E.CDFILIAL
                                          AND EN.DSENDEFILI IS NOT NULL
                                          AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                             )
                       UNION
                      /* Endereo de faturamento */
                      SELECT E.IDUSR_SAP_ME_ENDERECO_FAT IDUSR_SAP_ME_ENDERECO, E.CDFILIAL, 'F' IDTIPOENDERECO, I.CDPAIS,
                             P.NMPAIS, I.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, I.DSENDEIEST ENDERECO,
                             I.DSCOMPENDIES COMPLEMENTO, I.NMREPRINSEST CONTATO, I.NRTELEIEST TEL,
                             '' EMAIL, NVL(B.NMBAIRRO, I.NMBAIRIEST) BAIRRO,
                             I.NRCEPIEST CEP, 'P' IDTPENDE, NULL CDCLIENTE, E.IDTABELA, E.CDEMPRESA,
                             I.CDINSCESTA CDINSCESTA, CASE WHEN IDTABELA = 'E' THEN '1' ELSE '2' END IDTABALTTEK
                        FROM INSCRESTAD I INNER JOIN (SELECT F.CDFILIAL, EF.CDEMPRESA, EF.CDINSCESTA, EF.IDUSR_SAP_ME_ENDERECO_FAT, 'R' IDTABELA
                                                        FROM FILIAL F INNER JOIN EMPRCNTRFIL EF ON F.CDFILIAL = EF.CDFILIAL
                                                       UNION
                                                      SELECT F.CDFILIAL, EF.CDEMPRESA, F.CDINSCESTA, EF.IDUSR_SAP_ME_ENDERECO_FAT, 'E' IDTABELA
                                                        FROM FILIAL F INNER JOIN EMPRESA EF ON F.CDEMPRESA = EF.CDEMPRESA) E ON I.CDEMPRESA  = E.CDEMPRESA
                                                                                                                            AND I.CDINSCESTA = E.CDINSCESTA
                                          INNER JOIN PAIS P ON I.CDPAIS = P.CDPAIS
                                          INNER JOIN MUNICIPIO M ON M.CDPAIS      = I.CDPAIS
                                                                AND M.SGESTADO    = I.SGESTADO
                                                                AND M.CDMUNICIPIO = I.CDMUNICIPIO
                                          LEFT  JOIN BAIRRO B ON B.CDPAIS      = I.CDPAIS
                                                             AND B.SGESTADO    = I.SGESTADO
                                                             AND B.CDMUNICIPIO = I.CDMUNICIPIO
                                                             AND B.CDBAIRRO    = I.CDBAIRRO
                       WHERE I.DSENDEIEST IS NOT NULL
                         AND ((NVL(I.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                              (EXISTS (SELECT 1
                                         FROM ENDEFILI EN
                                        WHERE EN.CDFILIAL = E.CDFILIAL
                                          AND EN.DSENDEFILI IS NOT NULL
                                          AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                             )
                       UNION
                      /* Endereo de cobrana */
                      SELECT EF.IDUSR_SAP_ME_ENDERECO, EF.CDFILIAL, 'C' IDTIPOENDERECO, E.CDPAIS,
                             P.NMPAIS, E.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, E.DSENDEEMPR ENDERECO,
                             E.DSCOMPENDEMP COMPLEMENTO, E.NMCONTEMPR CONTATO, E.NRTELEFOEMPR TEL,
                             '' EMAIL, NVL(B.NMBAIRRO, E.NMBAIREMPR) BAIRRO,
                             E.NRCEPEMPR CEP, 'P' IDTPENDE, NULL CDCLIENTE, 'R' IDTABELA, EF.CDEMPRESA,
                             NULL CDINSCESTA, 'X' IDTABALTTEK
                        FROM EMPRESA E INNER JOIN EMPRCNTRFIL EF ON E.CDEMPRESA = EF.CDEMPRESA
                                       INNER JOIN PAIS P ON E.CDPAIS = P.CDPAIS
                                       INNER JOIN MUNICIPIO M ON M.CDPAIS      = E.CDPAIS
                                                             AND M.SGESTADO    = E.SGESTADO
                                                             AND M.CDMUNICIPIO = E.CDMUNICIPIO
                                       LEFT  JOIN BAIRRO B ON B.CDPAIS      = E.CDPAIS
                                                          AND B.SGESTADO    = E.SGESTADO
                                                          AND B.CDMUNICIPIO = E.CDMUNICIPIO
                                                          AND B.CDBAIRRO    = E.CDBAIRRO
                       WHERE E.DSENDEEMPR IS NOT NULL
                         AND ((NVL(EF.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                              (EXISTS (SELECT 1
                                         FROM ENDEFILI EN
                                        WHERE EN.CDFILIAL = EF.CDFILIAL
                                          AND EN.DSENDEFILI IS NOT NULL
                                          AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                             )
                       UNION
                      SELECT E.IDUSR_SAP_ME_ENDERECO, F.CDFILIAL, 'C' IDTIPOENDERECO, E.CDPAIS,
                             P.NMPAIS, E.SGESTADO, M.CDMUNICIPIO, M.NMMUNICIPIO, E.DSENDEEMPR ENDERECO,
                             E.DSCOMPENDEMP COMPLEMENTO, E.NMCONTEMPR CONTATO, E.NRTELEFOEMPR TEL,
                             '' EMAIL, NVL(B.NMBAIRRO, E.NMBAIREMPR) BAIRRO,
                             E.NRCEPEMPR CEP, 'P' IDTPENDE, NULL CDCLIENTE, 'E' IDTABELA, E.CDEMPRESA,
                             NULL CDINSCESTA, 'E' IDTABALTTEK
                        FROM FILIAL F INNER JOIN EMPRESA E ON E.CDEMPRESA = F.CDEMPRESA
                                      INNER JOIN PAIS P ON E.CDPAIS = P.CDPAIS
                                      INNER JOIN MUNICIPIO M ON M.CDPAIS      = E.CDPAIS
                                                            AND M.SGESTADO    = E.SGESTADO
                                                            AND M.CDMUNICIPIO = E.CDMUNICIPIO
                                      LEFT  JOIN BAIRRO B ON B.CDPAIS      = E.CDPAIS
                                                         AND B.SGESTADO    = E.SGESTADO
                                                         AND B.CDMUNICIPIO = E.CDMUNICIPIO
                                                         AND B.CDBAIRRO    = E.CDBAIRRO
                       WHERE E.DSENDEEMPR IS NOT NULL
                         AND ((NVL(E.USR_IDINTEGRAMESAP, 'S') = 'S') OR
                             (EXISTS (SELECT 1
                                         FROM ENDEFILI EN
                                        WHERE EN.CDFILIAL = F.CDFILIAL
                                          AND EN.DSENDEFILI IS NOT NULL
                                          AND NVL(EN.USR_IDINTEGRAMESAP, 'N') = 'S'))
                             )
                         AND NOT EXISTS (SELECT 1
                                           FROM EMPRCNTRFIL X
                                          WHERE X.CDFILIAL = F.CDFILIAL
                                            AND X.CDEMPRESA = F.CDEMPRESA)
                       ORDER BY CDFILIAL, IDTIPOENDERECO, IDTABALTTEK) LOOP

      V_IDENTIFICADOR := NULL;
       IF C_ENDERECO.IDTIPOENDERECO    = 'E' THEN
         SELECT MAX(NMFILIAL), NVL(MAX(NRINSJURFILI), ' '), NVL(MAX(CDINSCESTA), ' ')
           INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
           FROM FILIAL
          WHERE CDFILIAL = C_ENDERECO.CDFILIAL;
      ELSIF C_ENDERECO.IDTIPOENDERECO = 'C' THEN
         IF C_ENDERECO.IDTABALTTEK = 'C' THEN
            SELECT MAX(NMRAZSOCCLIE), NVL(MAX(NRINSJURCLIE), ' '), NVL(MAX(NRINSESTCLIE), ' ')
              INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
              FROM CLIENTE
             WHERE CDCLIENTE = C_ENDERECO.CDCLIENTE;
         ELSE
            SELECT MAX(NMEMPRESA), NVL(MAX(NRINSJUREMPR), ' '), NVL(MAX(NRINSCESTA), ' ')
              INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
              FROM EMPRESA
             WHERE CDEMPRESA = C_ENDERECO.CDEMPRESA;
         END IF;
      ELSIF C_ENDERECO.IDTIPOENDERECO = 'F' THEN
         IF C_ENDERECO.IDTABALTTEK = 'C' THEN
            SELECT MAX(NMRAZSOCCLIE), NVL(MAX(NRINSJURCLIE), ' '), NVL(MAX(NRINSESTCLIE), ' ')
              INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
              FROM CLIENTE
             WHERE CDCLIENTE = C_ENDERECO.CDCLIENTE;
         ELSIF C_ENDERECO.IDTABALTTEK = '1' THEN
            SELECT MAX(I.NMREPRINSEST), NVL(MAX(I.NRINSJURIEST), ' '), NVL(MAX(I.CDINSCESTA), ' ')
              INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
              FROM FILIAL F, INSCRESTAD I
             WHERE F.CDFILIAL   = C_ENDERECO.CDFILIAL
               AND F.CDEMPRESA  = C_ENDERECO.CDEMPRESA
               AND F.CDINSCESTA = I.CDINSCESTA
               AND F.CDEMPRESA  = I.CDEMPRESA;
         ELSE
            SELECT MAX(I.NMREPRINSEST), NVL(MAX(I.NRINSJURIEST), ' '), NVL(MAX(I.CDINSCESTA), ' ')
              INTO V_DSLOCAL, V_NRINSJURFILI, V_CDINSCESTA
              FROM EMPRCNTRFIL F, INSCRESTAD I
             WHERE F.CDFILIAL   = C_ENDERECO.CDFILIAL
               AND F.CDEMPRESA  = C_ENDERECO.CDEMPRESA
               AND F.CDEMPRESA  = I.CDEMPRESA
               AND F.CDINSCESTA = I.CDINSCESTA;
         END IF;
      END IF;

      SELECT COUNT(IDENTIFIC)
        INTO V_IDENTIFIC
        FROM USR_SAP_ME_ENDERECO
       WHERE IDTIPOENDERECO = C_ENDERECO.IDTIPOENDERECO
         AND CDFILIAL       = C_ENDERECO.CDFILIAL
         AND IDTABALTTEK    = C_ENDERECO.IDTABALTTEK;

      /*Alteraao para sempre incluir endereo    180649 - Integrao Tecfood e ME endereos*/
      /*IF ((C_ENDERECO.IDUSR_SAP_ME_ENDERECO IS NULL)  OR (V_IDENTIFIC = 0))THEN */

         V_TPINTERFACE   := 'I';
         V_IDENTIFICADOR := USR_SAP_ME_EN_IDINTERFACE.NEXTVAL;

         INSERT INTO USR_SAP_ME_ENDERECO(ALTERACAO, IDENTIFIC, CDFILIAL, IDTIPOENDERECO, CDPAIS,
                                         PAIS, ESTADO, CDMUNICIPIO, MUNICIPIO, DSENDERECO,
                                         COMPLEMENTO, CONTATO, TEL, EMAIL, BAIRRO,
                                         CEP, CANCELADO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI,
                                         DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, IDTABALTTEK,
                                         NRINSJURFILI, CDINSCESTA, DSLOCAL)
              VALUES (V_ALTERACAO, LPAD(V_IDENTIFICADOR,10,'0'), C_ENDERECO.CDFILIAL, C_ENDERECO.IDTIPOENDERECO, C_ENDERECO.CDPAIS,
                      C_ENDERECO.NMPAIS, C_ENDERECO.SGESTADO, C_ENDERECO.CDMUNICIPIO, C_ENDERECO.NMMUNICIPIO, C_ENDERECO.ENDERECO,
                      C_ENDERECO.COMPLEMENTO, C_ENDERECO.CONTATO, C_ENDERECO.TEL, C_ENDERECO.EMAIL, C_ENDERECO.BAIRRO,
                      C_ENDERECO.CEP, 'N', V_IDENTIFICADOR, V_TPINTERFACE, SYSDATE,
                      NULL, V_STATUS, 1, 4, C_ENDERECO.IDTABALTTEK,
                      V_NRINSJURFILI, V_CDINSCESTA, V_DSLOCAL);
     /*Alteraao para sempre incluir endereo    180649 - Integrao Tecfood e ME endereos*/
     /* ELSE
         V_TPINTERFACE := 'A';

         UPDATE USR_SAP_ME_ENDERECO
            SET CDPAIS         = C_ENDERECO.CDPAIS,
                PAIS           = C_ENDERECO.NMPAIS,
                ESTADO         = C_ENDERECO.SGESTADO,
                CDMUNICIPIO    = C_ENDERECO.CDMUNICIPIO,
                MUNICIPIO      = C_ENDERECO.NMMUNICIPIO,
                DSENDERECO     = C_ENDERECO.ENDERECO,
                COMPLEMENTO    = C_ENDERECO.COMPLEMENTO,
                CONTATO        = C_ENDERECO.CONTATO,
                TEL            = C_ENDERECO.TEL,
                EMAIL          = C_ENDERECO.EMAIL,
                BAIRRO         = C_ENDERECO.BAIRRO,
                CEP            = C_ENDERECO.CEP,
                IDTIPOENDERECO = C_ENDERECO.IDTIPOENDERECO,
                TPINTERFACE    = V_TPINTERFACE,
                STATUS         = V_STATUS,
                APPORIGEM      = 1,
                APPDESTINO     = 4,
                NRINSJURFILI   = V_NRINSJURFILI,
                CDINSCESTA     = V_CDINSCESTA,
                DSLOCAL        = V_DSLOCAL,
                DTINTERFACEORI = SYSDATE,
                DTINTERFACEDEST= NULL
          WHERE IDTIPOENDERECO = C_ENDERECO.IDTIPOENDERECO
            AND CDFILIAL       = C_ENDERECO.CDFILIAL
            AND IDTABALTTEK    = C_ENDERECO.IDTABALTTEK;

         IF SQL%ROWCOUNT = 0 THEN
            V_TPINTERFACE   := 'I';
            V_IDENTIFICADOR := USR_SAP_ME_EN_IDINTERFACE.NEXTVAL;

            INSERT INTO USR_SAP_ME_ENDERECO(ALTERACAO, IDENTIFIC, CDFILIAL, IDTIPOENDERECO, CDPAIS,
                                            PAIS, ESTADO, CDMUNICIPIO, MUNICIPIO, DSENDERECO,
                                            COMPLEMENTO, CONTATO, TEL, EMAIL, BAIRRO,
                                            CEP, CANCELADO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI,
                                            DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, IDTABALTTEK,
                                            NRINSJURFILI, CDINSCESTA, DSLOCAL)
                 VALUES (V_ALTERACAO, LPAD(V_IDENTIFICADOR,10,'0'), C_ENDERECO.CDFILIAL, C_ENDERECO.IDTIPOENDERECO, C_ENDERECO.CDPAIS,
                         C_ENDERECO.NMPAIS, C_ENDERECO.SGESTADO, C_ENDERECO.CDMUNICIPIO, C_ENDERECO.NMMUNICIPIO, C_ENDERECO.ENDERECO,
                         C_ENDERECO.COMPLEMENTO, C_ENDERECO.CONTATO, C_ENDERECO.TEL, C_ENDERECO.EMAIL, C_ENDERECO.BAIRRO,
                         C_ENDERECO.CEP, 'N', V_IDENTIFICADOR, V_TPINTERFACE, SYSDATE,
                         NULL, V_STATUS, 1, 4, C_ENDERECO.IDTABALTTEK,
                         V_NRINSJURFILI, V_CDINSCESTA, V_DSLOCAL);
         END IF;
      END IF;

      IF C_ENDERECO.IDUSR_SAP_ME_ENDERECO IS NOT NULL THEN
         V_IDENTIFICADOR := C_ENDERECO.IDUSR_SAP_ME_ENDERECO;
      END IF; */

      IF C_ENDERECO.IDTIPOENDERECO = 'E' THEN
         UPDATE ENDEFILI
            SET USR_IDINTEGRAMESAP = 'N',
                IDUSR_SAP_ME_ENDERECO = V_IDENTIFICADOR
          WHERE CDFILIAL     = C_ENDERECO.CDFILIAL;
      ELSIF C_ENDERECO.IDTIPOENDERECO = 'F' THEN
         UPDATE CLIENFILIAL
               SET USR_IDINTEGRAMESAP = 'N'
             WHERE CDFILIAL  = C_ENDERECO.CDFILIAL; 
         UPDATE ENDEFILI
            SET USR_IDINTEGRAMESAP = 'N'
          WHERE CDFILIAL     = C_ENDERECO.CDFILIAL
            AND NVL(USR_IDINTEGRAMESAP, 'N') = 'S';    
         IF C_ENDERECO.CDCLIENTE IS NOT NULL THEN
            UPDATE ENDECLIE
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO_FAT = V_IDENTIFICADOR
             WHERE CDCLIENTE    = C_ENDERECO.CDCLIENTE
               AND IDTPENDECLIE = C_ENDERECO.IDTPENDE;
         ELSIF C_ENDERECO.IDTABELA = 'E' THEN
             UPDATE INSCRESTAD
                SET USR_IDINTEGRAMESAP = 'N'
              WHERE CDEMPRESA  = C_ENDERECO.CDEMPRESA
                AND CDINSCESTA = C_ENDERECO.CDINSCESTA;
         ELSIF C_ENDERECO.IDTABELA = 'R' THEN
           UPDATE INSCRESTAD
                SET USR_IDINTEGRAMESAP = 'N'
              WHERE CDEMPRESA  = C_ENDERECO.CDEMPRESA
                AND CDINSCESTA = C_ENDERECO.CDINSCESTA;
            UPDATE EMPRCNTRFIL
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO_FAT = V_IDENTIFICADOR
             WHERE CDFILIAL  = C_ENDERECO.CDFILIAL
               AND CDEMPRESA = C_ENDERECO.CDEMPRESA;            
         ELSE
            UPDATE EMPRESA
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO_FAT = V_IDENTIFICADOR
             WHERE CDEMPRESA = C_ENDERECO.CDEMPRESA;
             UPDATE INSCRESTAD
                SET USR_IDINTEGRAMESAP = 'N'
              WHERE CDEMPRESA  = C_ENDERECO.CDEMPRESA
                AND CDINSCESTA = C_ENDERECO.CDINSCESTA; 
         END IF;
      ELSIF C_ENDERECO.IDTIPOENDERECO = 'C' THEN

         UPDATE CLIENFILIAL
               SET USR_IDINTEGRAMESAP = 'N'
             WHERE CDFILIAL  = C_ENDERECO.CDFILIAL;
         UPDATE ENDEFILI
            SET USR_IDINTEGRAMESAP = 'N'
          WHERE CDFILIAL     = C_ENDERECO.CDFILIAL
            AND NVL(USR_IDINTEGRAMESAP, 'N') = 'S';
         IF C_ENDERECO.CDCLIENTE IS NOT NULL THEN
            UPDATE ENDECLIE
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO = V_IDENTIFICADOR
             WHERE CDCLIENTE    = C_ENDERECO.CDCLIENTE
               AND IDTPENDECLIE = C_ENDERECO.IDTPENDE;
         ELSIF C_ENDERECO.IDTABELA = 'R' THEN
            UPDATE EMPRCNTRFIL
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO = V_IDENTIFICADOR
             WHERE CDFILIAL  = C_ENDERECO.CDFILIAL
               AND CDEMPRESA = C_ENDERECO.CDEMPRESA;
         ELSIF C_ENDERECO.IDTABELA = 'E' THEN
            UPDATE EMPRESA
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO_FAT = V_IDENTIFICADOR
             WHERE CDEMPRESA = C_ENDERECO.CDEMPRESA; 
         ELSE
            UPDATE EMPRESA
               SET USR_IDINTEGRAMESAP = 'N',
                   IDUSR_SAP_ME_ENDERECO = V_IDENTIFICADOR
             WHERE CDEMPRESA = C_ENDERECO.CDEMPRESA;
         END IF;
      END IF;
      V_CCOMMIT := V_CCOMMIT + 1;
      IF V_CCOMMIT > 200 THEN
         COMMIT;
         V_CCOMMIT := 0;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPO_SAP_ME_ENDERECO','6.02.xxx'); END;
/